<template>
	<main>
		<div class="cards">
			<h1>Registrierung</h1>
			<div class="card-body">
				<form v-on:submit.prevent class="cols c-1-1 mobile-flex">
					<div>
						<div class="cell">E-Mail Adresse</div>
						<div class="cell"><input ref="email" v-model="form.email" class="input input--full-w" type="email" name="email" /></div>
						<div class="cell">User Name</div>
						<div class="cell"><input ref="name" v-model="form.name" class="input input--full-w" type="text" name="name" /></div>
						<div class="cell">Passwort</div>
						<div class="cell"><input ref="password" v-model="form.password" class="input input--full-w" type="password" name="password" /></div>
						<div class="cell">Passwort wiederholen</div>
						<div class="cell"><input ref="passwordRepeat" v-model="form.passwordRepeat" class="input input--full-w" type="password" name="passwordRepeat" /></div>
					</div>
					<div class="mobile-order-m-1">
						<div class="cell">
							Registriere Dich!
						</div>
					</div>
					<div class="col--merged">
						<div class="cell">
							<button type="submit" @click="registerUser" class="button button--mobile-stretch">Registrieren</button>
						</div>
					</div>
				</form>
			</div>
		</div>
		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</main>
</template>

<script>
import SystemMessage from "@/components/SystemMessage";

export default {
	name: "Register",
	components: {SystemMessage},
	data: () => ({
		form: {
			email: "",
			name: "",
			password: "",
			passwordRepeat: ""
		},
		sysMsg: undefined
	}),
	methods: {
		async registerUser() {
			this.sysMsg = "";
			let verified = this.globalValidateForm();

			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			if (this.form.password.trim().localeCompare(this.form.passwordRepeat.trim()) !== 0) {
				this.$refs.password.classList.add("input--alert");
				this.$refs.passwordRepeat.classList.add("input--alert");
				this.$refs.password.focus();
				this.sysMsg = "Passwörter stimmen nich überein!";
				return;
			}


			try {
				const response = await this.$http.post("/api/register", this.form);
				switch (response.status) {
					case 201:
						this.globalEmptyForm();
						this.sysMsg = "Erfolgreich registriert!";
						this.$refs.email.focus();
						setTimeout(() => this.$router.push("/home"), 2000);
						break;
				}
			} catch (e) {
				switch (e.response.data) {
					case "missing_input":
						this.sysMsg = "Fehlende Eingaben!";
						break;
					case "duplicate":
						this.sysMsg = "E-Mail Adresse bereits vergeben!";
						this.$refs.email.classList.add("input--alert");
						this.$refs.email.focus();
						break;
					case "invalid_mail_pattern":
						this.sysMsg = "Ungültige E-Mail Adresse!";
						this.$refs.email.classList.add("input--alert");
						this.$refs.email.focus();
						break;
					case "user_name_length":
						this.sysMsg = "User Name muss zw. 3 und 15 Zeichen lang sein!";
						this.$refs.name.classList.add("input--alert");
						this.$refs.name.focus();
						break;
					case "password_mismatch":
						this.sysMsg = "Passwörter stimmen nich überein!";
						this.$refs.password.classList.add("input--alert");
						this.$refs.passwordRepeat.classList.add("input--alert");
						this.$refs.password.focus();
						break;
					default:
						console.error(e.response);
				}
			}
		}
	}
}
</script>

<style scoped>

</style>